Codeforces-697C Lorenzo Von Matterhorn

Barney lives in NYC. NYC has infinite number of intersections numbered with positive integers starting from 1. There exists a bidirectional road between intersections i and 2i and another road between i and 2i + 1 for every positive integer i. You can clearly see that there exists a unique shortest path between any two intersections.

Initially anyone can pass any road for free. But since SlapsGiving is ahead of us, there will q consecutive events happen soon. There are two types of events:

1. Government makes a new rule. A rule can be denoted by integers vu and w. As the result of this action, the passing fee of all roads on the shortest path from u to v increases by w dollars.

2. Barney starts moving from some intersection v and goes to intersection u where there's a girl he wants to cuddle (using his fake name Lorenzo Von Matterhorn). He always uses the shortest path (visiting minimum number of intersections or roads) between two intersections.

Government needs your calculations. For each time Barney goes to cuddle a girl, you need to tell the government how much money he should pay (sum of passing fee of all roads he passes).

Input

The first line of input contains a single integer q (1 ≤ q ≤ 1 000).

The next q lines contain the information about the events in chronological order. Each event is described in form 1 v u w if it's an event when government makes a new rule about increasing the passing fee of all roads on the shortest path from u to v by w dollars, or in form 2 v u if it's an event when Barnie goes to cuddle from the intersection v to the intersection u.

1 ≤ v, u ≤ 1018, v ≠ u, 1 ≤ w ≤ 109 states for every description line.

Output

For each event of second type print the sum of passing fee of all roads Barney passes in this event, in one line. Print the answers in chronological order of corresponding events.

Example
input
7
1 3 4 30
1 4 1 2
1 3 6 8
2 4 3
1 6 1 40
2 3 7
2 2 4
output
94
0
32
Note

In the example testcase:

Here are the intersections used:

  1. Intersections on the path are 312 and 4.
  2. Intersections on the path are 42 and 1.
  3. Intersections on the path are only 3 and 6.
  4. Intersections on the path are 421 and 3. Passing fee of roads on the path are 3232 and 30 in order. So answer equals to32 + 32 + 30 = 94.
  5. Intersections on the path are 63 and 1.
  6. Intersections on the path are 3 and 7. Passing fee of the road between them is 0.
  7. Intersections on the path are 2 and 4. Passing fee of the road between them is 32 (increased by 30 in the first event and by 2 in the second).


题目大意:先给出q次操作,当输入1的时候,表示一棵完全二叉树的两个节点u、v之间最短路径的权值全部加上w,当输入2的时候,表示询问这棵树的u到v节点间最短路径的权值之和。
解题思路:其实没什么特别的。。。我一开始想的是 最近公共祖先+哈希+搜索,其实没那么麻烦,就map暴力搞就行0.0
代码:
#include <map>
#include <cstdio>
#include <vector>
#include <cstring>
using namespace std;
typedef long long LL;
map<LL, LL> m;
LL solve(LL u, LL v, LL w){
	vector<LL> vec;
	vec.clear();

	LL t = u, flag = 1;
	while(t){
		vec.push_back(t);
		t /= 2;
	}
	int len = vec.size();
	t = v;
	while(t){
		for(int i = 0; i < len; ++i){
			if(t == vec[i]) {flag = 0; break;}
		}
		if(!flag) break;
		t /= 2; 
	}

	if(w == -1){
		LL ans = 0;
		while(u != t){
			ans += m[u];
			u /= 2;
		}
		while(v != t){
			ans += m[v];
			v /= 2;
		}
		return ans;
	}else{
		while(u != t){
			m[u] += w;
			u /= 2;
		}
		while(v != t){
			m[v] += w;
			v /= 2;
		}
	}
	return 1LL;
}
int main()
{
	// freopen("test.in", "r+", stdin);
	// freopen("test.out", "w+", stdout);
	m.clear();
	LL q, op, u, v, w;
	scanf("%I64d", &q);
	while(q--){
		scanf("%I64d", &op);
		if(op == 1){
			scanf("%I64d%I64d%I64d", &u, &v, &w);

			solve(u, v, w);
		}else{
			scanf("%I64d%I64d", &u, &v);
			LL ans = solve(u, v, -1);
			printf("%I64d
", ans);
		}
	}
	return 0;
}

不过讲道理,,,我看我的代码写的实在是搓,看到一个毛子写的代码如下:
#include <iostream>
#include <map>

using namespace std;

map<long long, long long> mp;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int q;
    cin >> q;
    for(int qq = 0; qq < q; qq++) {
        int t;
        cin >> t;
        if(t == 1) {
            long long v, u, w;
            cin >> v >> u >> w;
            while(v != u) {
                if(v < u)
                    swap(v, u);
                mp[v] += w;
                v /= 2;
            }
        }
        else {
            long long v, u;
            cin >> v >> u;
            long long ans = 0;
            while(v != u) {
                if(v < u)
                    swap(v, u);
                ans += mp[v];
                v /= 2;
            }
            cout << ans << '
';
        }
    }
    return 0;
}

感觉还要继续努力啊。代码能力和思维能力还要继续提高~~

原文地址:https://www.cnblogs.com/wiklvrain/p/8179467.html